# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_with	verbose		# verbose build (V=1)

%if "%{_alt_kernel}" != "%{nil}"
%if 0%{?build_kernels:1}
%{error:alt_kernel and build_kernels are mutually exclusive}
exit 1
%endif
%global		_build_kernels		%{alt_kernel}
%else
%global		_build_kernels		%{?build_kernels:,%{?build_kernels}}
%endif

# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0

%define		kpkg	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo %%kernel_pkg ; done)
%define		bkpkg	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo %%build_kernel_pkg ; done)
%define		ikpkg	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo %%install_kernel_pkg ; done)

%define		rel	2
%define		pname	ixgbe
Summary:	Intel(R) 10 Gigabit driver for Linux
Summary(pl.UTF-8):	Sterownik do karty Intel(R) 10 Gigabit
Name:		%{pname}%{_alt_kernel}
Version:	3.22.3
Release:	%{rel}@%{_kernel_ver_str}
License:	GPL v2
Group:		Base/Kernel
Source0:	http://downloads.sourceforge.net/e1000/%{pname}-%{version}.tar.gz
# Source0-md5:	6ba474edde8c1fa205ee3b9a3af0587f
Patch0:		linux-3.17.patch
URL:		http://sourceforge.net/projects/e1000/
%{?with_dist_kernel:BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.20.2}
BuildRequires:	rpmbuild(macros) >= 1.678
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This package contains the Linux driver for the Intel(R) 10 Gigabit
adapters with 82598EB chipset.

%description -l pl.UTF-8
Ten pakiet zawiera sterownik dla Linuksa do kart sieciowych z rodziny
Intel(R) 10 Gigabit opartych o układ 82598EB.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-net-ixgbe\
Summary:	Intel(R) 10 Gigabit driver for Linux\
Summary(pl.UTF-8):	Sterownik do karty Intel(R) 10 Gigabit\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%if %{with dist_kernel}\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
%endif\
\
%description -n kernel%{_alt_kernel}-net-ixgbe\
This package contains the Linux driver for the Intel(R) 10 Gigabit\
adapters with 82598EB chipset.\
\
%description -n kernel%{_alt_kernel}-net-ixgbe -l pl.UTF-8\
Ten pakiet zawiera sterownik dla Linuksa do kart sieciowych z rodziny\
Intel(R) 10 Gigabit opartych o układ 82598EB.\
\
%files	-n kernel%{_alt_kernel}-net-ixgbe\
%defattr(644,root,root,755)\
%doc ixgbe.7 README\
/etc/modprobe.d/%{_kernel_ver}/%{pname}.conf\
/lib/modules/%{_kernel_ver}/kernel/drivers/net/%{pname}*.ko*\
\
%post	-n kernel%{_alt_kernel}-net-ixgbe\
%depmod %{_kernel_ver}\
\
%postun	-n kernel%{_alt_kernel}-net-ixgbe\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%build_kernel_modules -C src -m %{pname}\
%install_kernel_modules -D installed -m src/%{pname} -d kernel/drivers/net -n %{pname} -s current\
%{nil}

%define install_kernel_pkg()\
install -d $RPM_BUILD_ROOT/etc/modprobe.d/%{_kernel_ver}\
# blacklist kernel module\
cat > $RPM_BUILD_ROOT/etc/modprobe.d/%{_kernel_ver}/%{pname}.conf <<'EOF'\
blacklist ixgbe\
alias ixgbe ixgbe-current\
EOF\
%{nil}

%{expand:%kpkg}

%prep
%setup -q -n %{pname}-%{version}
%patch0 -p1

cp src/Makefile src/Makefile.%{name}
cat > src/Makefile <<'EOF'
obj-m := ixgbe.o
ixgbe-objs := ixgbe_main.o ixgbe_common.o ixgbe_api.o ixgbe_param.o \
ixgbe_lib.o ixgbe_ethtool.o kcompat.o ixgbe_82598.o \
ixgbe_82599.o ixgbe_ptp.o ixgbe_x540.o ixgbe_sriov.o \
ixgbe_mbx.o ixgbe_dcb.o ixgbe_dcb_82598.o ixgbe_dcb_82599.o \
ixgbe_sysfs.o ixgbe_procfs.o ixgbe_phy.o ixgbe_fcoe.o \
ixgbe_dcb_nl.o ixgbe_dcb_nl.o ixgbe_debugfs.o

EXTRA_CFLAGS+=-DDRIVER_IXGBE
EXTRA_CFLAGS+=-DIXGBE_PTP
EOF

%build
%{expand:%bkpkg}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT

%{expand:%ikpkg}
cp -a installed/* $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT
%changelog
* Sun Nov 23 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ixgbe.git;a=log;h=auto/th/ixgbe-3.22.3-2

* Sun Nov 09 2014 Jan Rękorajski <baggins@pld-linux.org> 073cf0e
- fix building on linux 3.17+
- rel 2

* Mon Aug 25 2014 Jan Rękorajski <baggins@pld-linux.org> d48220b
- up to 3.22.3

* Sat Jul 12 2014 Jan Rękorajski <baggins@pld-linux.org> 4249275
- fix building with linux 3.15
- rel 2

* Sat Apr 26 2014 Jan Rękorajski <baggins@pld-linux.org> 1275747
- up to 3.21.2

* Sun Oct 27 2013 Jan Rękorajski <baggins@pld-linux.org> 059680c
- switch to macro driven module build for multiple kernel versions
- rel 8

* Mon Oct 07 2013 Jan Rękorajski <baggins@pld-linux.org> f812a63
- rebuild for kernel-3.10.15-1
- release 7 (by relup.sh)

* Wed Oct 02 2013 Jan Rękorajski <baggins@pld-linux.org> b6c4b00
- rebuild for kernel-3.10.14-1
- release 6 (by relup.sh)

* Fri Sep 27 2013 Jan Rękorajski <baggins@pld-linux.org> 2258fba
- rebuild for kernel-3.10.13-1
- release 5 (by relup.sh)

* Sun Sep 15 2013 Jan Rękorajski <baggins@pld-linux.org> b12dacc
- rebuild for kernel-3.10.12-1
- release 4 (by relup.sh)

* Tue Sep 10 2013 Jan Rękorajski <baggins@pld-linux.org> 018b216
- rebuild for kernel-3.10.11-1
- release 3 (by relup.sh)

* Thu Aug 29 2013 Jan Rękorajski <baggins@pld-linux.org> 66bf080
- rebuild for kernel-3.10.10-1
- release 2 (by relup.sh)

* Sun Aug 25 2013 Jan Rękorajski <baggins@pld-linux.org> d23ea0a
- up to 3.17.3

* Sat Aug 24 2013 Jan Rękorajski <baggins@pld-linux.org> 3b049f3
- rebuild for kernel-3.10.9-1
- release 9 (by relup.sh)

* Thu Aug 15 2013 Jan Rękorajski <baggins@pld-linux.org> ec8c61f
- release 8 (by relup.sh)

* Thu Jul 25 2013 Jan Rękorajski <baggins@pld-linux.org> 51d90d1
- rebuild for kernel-3.9.11-1
- release 7 (by relup.sh)

* Wed Jul 03 2013 Jan Rękorajski <baggins@pld-linux.org> e5ec0ea
- rebuild for kernel-3.9.9-1
- release 6 (by relup.sh)

* Thu Jun 27 2013 Jan Rękorajski <baggins@pld-linux.org> fe4a882
- rebuild for kernel-3.9.8-1
- release 5 (by relup.sh)

* Thu Jun 20 2013 Jan Rękorajski <baggins@pld-linux.org> 4bab646
- rebuild for kernel-3.9.7-1
- release 4 (by relup.sh)

* Thu Jun 13 2013 Jan Rękorajski <baggins@pld-linux.org> c9ef66e
- rebuild for kernel-3.9.6-1
- release 3 (by relup.sh)

* Fri Jun 07 2013 Jan Rękorajski <baggins@pld-linux.org> 911ba95
- rebuild for kernel-3.9.5-1 /home/users/baggins/devel/PLD/rpm/packages
- release 2 (by relup.sh)

